<template>
    <v-container>
        <v-flex md12>
            <h1 v-if="type === 'edit'">Editer un film</h1>
            <h1 v-else>Ajouter un film</h1>
        </v-flex>
        <v-form ref="form" v-model="valid">
            <v-layout row wrap justify-center>
                <v-flex md2 v-if="!edit_picture && (type === 'edit')" style="position: relative">
                    <v-img
                            :src="urlImage(movie)"
                            height="300px"
                            width="200px"
                    ></v-img>
                    <v-btn
                            absolute
                            top
                            fab
                            small
                            dark
                            icon
                            v-on:click="editPicture"
                            color="check"
                            class="edit-picture"
                    >
                        <v-icon>edit</v-icon>
                    </v-btn>
                </v-flex>
                <v-flex md12 v-else>
                    <file-upload :movie="getMovie" v-on:image-loaded="imageNull = false" v-on:remove="deleteImageFromApi" v-on:setImage="setImage"></file-upload>
                </v-flex>
                <v-flex xs12 sm12 md12>
                    <v-rating v-model="rating"
                              class="stars"
                              background-color="primary lighten-3"
                              color="primary"
                              dense
                    ></v-rating>
                </v-flex>
                <v-flex xs12 sm11 md11>
                    <v-text-field label="Titre" v-model="title" :rules="requiredRules"></v-text-field>
                </v-flex>
                <v-flex xs12 sm11 md11>
                    <v-text-field label="Année" v-model="year" :rules="requiredRules" mask="####"></v-text-field>
                </v-flex>
                <v-flex xs12 sm11 md11>
                    <v-text-field label="Genre" v-model="gender" :rules="requiredRules"></v-text-field>
                </v-flex>
                <v-flex xs12 sm11 md11>
                    <v-textarea label="Synopsis" v-model="synopsys" :rules="requiredRules"></v-textarea>
                </v-flex>
                <v-flex xs12 sm11 md11>
                    <h3>Réalisateur</h3>
                </v-flex>
                <v-flex xs12 sm11 md11>
                    <v-text-field label="Nom" v-model="director_name" :rules="requiredRules"></v-text-field>
                </v-flex>
                <v-flex xs12 sm11 md11>
                    <v-text-field label="Nationalité" v-model="director_country" :rules="requiredRules"></v-text-field>
                </v-flex>
                <v-flex xs12 sm11 md11>
                    <v-text-field label="Date de naissance (JJ-MM-AAAA)" v-model="director_birthday" :rules="requiredRules" mask="##-##-####"></v-text-field>
                </v-flex>
                <v-btn
                        :dark="valid && (!imageNull || getMovie.infos.imageAuto !== '')"
                        :disabled="!valid || (imageNull && !getMovie.infos.imageAuto)"
                        color="check"
                        @click="submit"
                >Editer
                </v-btn>
            </v-layout>
        </v-form>
    </v-container>
</template>

<script>
    import {mapMutations, mapGetters, mapActions} from 'vuex'
    import FileUpload from "./microComponents/fileUpload";
    export default {
        name: "movieCreate",
        components: {FileUpload},
        props: ['type'],
        data() {
            return {
                valid: false,
                edit_picture: false,
                requiredRules: [
                    v => !!v || "ce champs est requis"
                ],
                imageNull: true
            }
        },
        mounted () {
            this.setMovieParam({clear: true});
            if (this.type === "edit") {
                this.getMovieFromAPI(this.$route.params.id)
            }
        },
        methods: {
            ...mapMutations({
                setMovieParam: 'movieManagement/setMovieParam',
                setApiImage: 'movieManagement/setApiImage'
            }),
            ...mapActions({
                getMovieFromAPI: 'movieManagement/getMovieFromAPI',
                getImageFromServer: 'movieManagement/getImageFromApi',
                setMovieToAPI: 'movieManagement/setMovieToAPI'
            }),
            submit: function () {
                if (this.$refs.form.validate()) {
                    this.setMovieToAPI(this.type).then(() => {
                        this.$router.push({path: '/'});
                        if (!this.imageNull) {
                            location.reload()
                        }
                    })
                }


            },
            setImage (file) {
                this.setMovieParam({info: false, val: file});
                this.imageNull = false
            },
            deleteImageFromApi () {
                this.setMovieParam({info: true, prop: 'imageAuto', val: ""})
            },
            urlImage(movie) {
                if (movie.infos && !movie.infos.imageAuto) {
                    return './../static/'+movie.infos._id+'.png'
                } else {
                    return movie.infos.imageAuto
                }
            },
            editPicture () {
                this.edit_picture = true;
                if (this.movie.infos.imageAuto) {
                    this.tmp_picture = this.movie.infos.imageAuto;
                    this.deleteImageFromApi()
                }
            }
        },
        computed: {
            ...mapGetters({
                getMovie: 'movieManagement/getMovie',
                getErrors: 'movieManagement/getErrors'
            }),
            movie: {
                get () {
                    return this.getMovie
                }
            },
            title: {
                get () {
                    return this.getMovie.infos.title
                },
                set (value) {
                    this.setMovieParam({prop: "title", info: true, val: value})
                }
            },
            year: {
                get () {
                    return this.getMovie.infos.year
                },
                set (value) {
                    this.setMovieParam({prop: "year", info: true, val: value})
                }
            },
            gender: {
                get () {
                    return this.getMovie.infos.gender
                },
                set (value) {
                    this.setMovieParam({prop: "gender", info: true, val: value})
                }
            },
            synopsys: {
                get () {
                    return this.getMovie.infos.synopsys
                },
                set (value) {
                    this.setMovieParam({prop: "synopsys", info: true, val: value})
                }
            },
            director_name: {
                get () {
                    return this.getMovie.infos.director.name
                },
                set (value) {
                    this.setMovieParam({prop: "director", prop2: "name", info: true, val: value})
                }
            },
            director_country: {
                get () {
                    return this.getMovie.infos.director.country
                },
                set (value) {
                    this.setMovieParam({prop: "director", prop2: "country", info: true, val: value})
                }
            },
            director_birthday: {
                get () {
                    return this.getMovie.infos.director.birthday
                },
                set (value) {
                    this.setMovieParam({prop: "director", prop2: "birthday", info: true, val: value})
                }
            },
            rating: {
                get () {
                    return this.getMovie.infos.rating
                },
                set (value) {
                    this.setMovieParam({prop: "rating", info: true, val: value})
                }
            }
        },
        beforeRouteLeave (to, from, next) {
            this.setApiImage("");
            this.setMovieParam({clear: true});
            next()
        }
    }
</script>

<style scoped>
    .edit-picture {
        top: 280px !important;
    }
    .stars {
        margin: 30px;
    }
</style>
